Imports System.Data
Imports System
Imports System.Configuration
Imports System.Web
Imports System.Web.Security
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.WebControls.WebParts
Imports System.Web.UI.HtmlControls
Imports AIAPortal
Imports System.Collections
Imports System.Xml
Imports Microsoft.VisualBasic
Imports System.ComponentModel
Imports System.Drawing
Imports System.Web.SessionState
Imports System.IO
Imports System.Runtime.Serialization
Imports System.Runtime.Serialization.Formatters
Imports System.Runtime.Serialization.Formatters.Soap
Imports System.Runtime.Serialization.Formatters.Binary
Imports Syncfusion.Windows.Forms.Diagram




Partial Class MainWindow
    Inherits System.Web.UI.Page

    Private bHasChanges As Boolean


    Dim Util As AIAPortalUtil
    Dim Db As AIAPortalDB

    Private SelectedChartItem As String = ""



    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private ActiveTab As Integer

    Private PatientName As String
    Private theFilter As Integer






    ' This is the event that fires when a node in the tree is selected. Use it for things like
    ' performing custom actions for the node or for processing data for a call to another method.


    '==========================================================================================================
    Protected Sub TreeView1_SelectedNodeChanged(ByVal sender As Object, ByVal e As EventArgs) Handles tvType.SelectedNodeChanged

        'NodeText.Text = tvType.SelectedNode.Text
        'NodeUrl.Text = tvType.SelectedNode.Value
        '  Dim urlWrapper As UrlParameterPasser

        Dim aFile As String = ""
        Dim myDataRow As DataRow
        Try

           
            'If IsPostBack Then Return

            If tvType.SelectedNode() Is Nothing Then Return
            'SelectedChartItem = tvType.SelectedNode().Text()

            If tvType.SelectedNode.Text() = PatientName Or tvType.SelectedNode.Text() = SelectedChartItem Then

                Me.dwcWorklet.RenderImageMap = True
                Return
            End If

            SelectedChartItem = tvType.SelectedNode.Text() 'update name

            If tvType.SelectedNode.Text() = "Profile" Then
                'If MainWin.DemographicsForm Is Nothing Then

                '    MainWin.DemographicsForm = New FrmPatientsDemographics(MainWin, DEMOMODE, SSN)
                'Else
                '    MainWin.DemographicsForm.SetControls()
                '    MainWin.DemographicsForm.BringToFront()
                'End If

                'MainWin.DemographicsForm.Show()
                'MainWin.DemographicsForm.DoPopulate(SSN)



                bTab6_Click(sender, e)
                Return


            ElseIf tvType.SelectedNode.Text() = "Rules" Then

                bTab5_Click(sender, e)
                Return

            ElseIf tvType.SelectedNode().Parent().Text() = "Rules" Then
                bTab5_Click(sender, e)
                Return

            ElseIf tvType.SelectedNode.Text() = "Queries" Then

                bTab3_Click(sender, e)
                Return

            ElseIf tvType.SelectedNode().Parent().Text() = "Queries" Then
                bTab3_Click(sender, e)
                Return

            ElseIf tvType.SelectedNode.Text() = "Worklets" Then


                'If MainWin.MessageForm Is Nothing Then
                '    MainWin.MessageForm = New FrmMessage(MainWin, SSN, "-1", 0)
                'Else
                '    MainWin.MessageForm.BringToFront()
                'End If

                'MainWin.MessageForm.Show()
                'MainWin.MessageForm.PopulateForm(SSN, "-1", 0)

                bTab2_Click(sender, e)
                Return
            ElseIf tvType.SelectedNode().Parent().Text() = "Worklets" Then


                bTab2_Click(sender, e)



                If (Not (DcDbProvider.Tables("InfoGlue.Worklets") Is Nothing)) Then
                    myDataRow = DcDbProvider.Find("InfoGlue.Worklets", tvType.SelectedNode.Text())
                    If (Not (myDataRow Is Nothing)) Then
                        aFile = (myDataRow("Path").ToString()) + (tvType.SelectedNode.Text()) + ".bpel"
                    End If

                End If



                'processXML(aFile)
                CreateWorkletDiagram()

                Me.dwcWorklet.EnableNodeSelection = True
                Me.dwcWorklet.EnableDragDrop = True
                Me.dwcWorklet.RenderImageMap = True

                Return
            ElseIf tvType.SelectedNode.Text() = "Ontologies" Then



                bTab4_Click(sender, e)
                Return


            ElseIf tvType.SelectedNode().Parent().Text() = "Ontologies" Then
                bTab4_Click(sender, e)
                Return



            End If


        Catch myException As Exception
            MsgBox(myException.ToString(), MsgBoxStyle.Critical)
        Finally
            'MainWin.Cursor = System.Windows.Forms.Cursors.Default
        End Try



        




    End Sub 'TreeView1_SelectedNodeChanged


    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Init, Me.Load
        Dim urlWrapper As UrlParameterPasser

        Util = New AIAPortalUtil
        Db = New AIAPortalDB


        urlWrapper = New UrlParameterPasser()



        If ViewState("InitCR") = "" Then 'only once
            ViewState("InitCR") = "1"

            ' Receive the parameters


            theFilter = CInt(urlWrapper.item("Filter"))

            If theFilter = 0 Then
                theFilter = ALLMODE
            End If

            'theFilter = WORKLETMODE
            'theFilter = QUERYMODE
            'theFilter = QUERYMODE


            'ReturnURL = urlWrapper.item("ReturnURL")


            ContentPanel.Height = pView.Height
            DetailContentPanel.Height = ContentPanel.Height



            populateTemplateList(theFilter, False)


        End If

    End Sub


    'Protected Sub bbtnClear_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnClear.Click
    '    clearFields()

    'End Sub


    Private Sub doRefresh()
        Try
            'MainWin.Cursor = System.Windows.Forms.Cursors.WaitCursor
            If DcDbProvider.SetDbConnection() = 0 Then
                Return
            End If

            'DcDbProvider.RefreshChart("", True, "Active Patients", False)
            'DcDbProvider.RefreshTable("InfoGlue.Patients", True, "SSN", SSN)


            If (theFilter = ALLMODE) Then

                DcDbProvider.RefreshTable("InfoGlue.Reports", False, Nothing, Nothing)
                'DcDbProvider.RefreshTable("InfoGlue.Attachments", True, "SSN", SSN)
                'DcDbProvider.RefreshTable("InfoGlue.Messages", True, "SSN", SSN)

                'DcDbProvider.RefreshTable("Encounters", True, "SSN", SSN)
                'DcDbProvider.RefreshTable("InfoGlue.Encounters", False, "SSN", SSN)

                DcDbProvider.RefreshTable("InfoGlue.Worklets", True, Nothing, Nothing)


            ElseIf (theFilter = WORKLETMODE) Then
                DcDbProvider.RefreshTable("InfoGlue.Worklets", True, Nothing, Nothing)


            ElseIf (theFilter = LABREPORTMODE) Then
                DcDbProvider.RefreshTable("Reports", True, Nothing, Nothing)

            End If


        Catch myException As Exception
        Finally

            'MainWin.Cursor = System.Windows.Forms.Cursors.Default
        End Try
    End Sub

    '''''''''''''''''''''''''''''''''''''''''''''''''''''''populateTemplateList''''''''''''''''''''''''''''''''''''''''''''''
    Public Sub populateTemplateList(ByVal filter As Integer, ByVal notShowSignOff As Boolean)
        Dim myDataRow As DataRow


        Dim rtb As String = ""
        Dim attNode As New TreeNode

        Dim aNode As TreeNode
        Try

            If IsPostBack Then Return


            theFilter = filter

            doRefresh()



            aNode = New TreeNode("Views")

            aNode.ImageUrl = "~/AIA/Images/open2.jpg"

            tvType.Nodes.Remove(aNode)
            tvType.Nodes.Add(aNode)

            If (theFilter = ALLMODE) Then

                Dim demoNode As New TreeNode("My Views")
                demoNode.ImageUrl = "~/AIA/Images/MyView.jpg"
                aNode.ChildNodes.Add(demoNode)
            End If



            If ((theFilter = ALLMODE) Or (theFilter = QUERYMODE) Or (theFilter = WORKLETMODE)) Then
                Dim msgNode As New TreeNode("Worklets")
                aNode.ChildNodes.Add(msgNode)
                msgNode.ImageUrl = "~/AIA/Images/worklet2Tree.jpg"


                If (Not (DcDbProvider.Tables("InfoGlue.Worklets") Is Nothing)) Then

                    For Each myDataRow In DcDbProvider.Rows("InfoGlue.Worklets")


                        Dim mNode As New TreeNode(myDataRow("Worklet").ToString())

                        mNode.ImageUrl = "~/AIA/Images/worklet2Tree.jpg"

                        If (theFilter = ALLMODE) Then
                            msgNode.ChildNodes.Add(mNode)
                        Else
                            msgNode.ChildNodes.Add(mNode)
                        End If

                        'End If

                    Next
                End If

            End If
            If ((theFilter = ALLMODE) Or (theFilter = QUERYMODE)) Then

                Dim encNode As New TreeNode("Queries")

                aNode.ChildNodes.Add(encNode)
                encNode.ImageUrl = "~/AIA/Images/queryTree.jpg"

            End If



            If ((theFilter = ALLMODE) Or (theFilter = ONTOMODE)) Then
                attNode = New TreeNode("Ontologies")

                attNode.ImageUrl = "~/AIA/Images/ontologyTree.jpg"


                If (theFilter = ALLMODE) Then
                    aNode.ChildNodes.Add(attNode)

                Else
                    aNode.ChildNodes.Add(attNode)
                End If



                'Dim ReportNode As New TreeNode("Lab Reports")
                'ReportNode.ImageUrl = "~/AIA/Images/labReports.jpg"
                'If (theFilter = ALLMODE) Then
                '    attNode.ChildNodes.Add(ReportNode)

                'Else
                '    attNode.ChildNodes.Add(ReportNode)
                'End If



            End If


            'If ((theFilter = ALLMODE) Or (theFilter = IMAGEMODE)) Then
            '    Dim attImagesNode As New TreeNode("Images")
            '    attImagesNode.ImageUrl = "~/AIA/Images/ImageIcon.jpg"

            '    If (theFilter = ALLMODE) Then
            '        attNode.ChildNodes.Add(attImagesNode)

            '    Else
            '        attNode.ChildNodes.Add(attImagesNode)
            '    End If


            '    If (Not (DcDbProvider.Tables("Attachments") Is Nothing)) Then

            '        For Each myDataRow In DcDbProvider.Rows("Attachments")

            '            If (myDataRow("SSN").ToString()) = SSN And (myDataRow("ItemType") = ATIMAGE) Then

            '                If myDataRow("RTF") Then
            '                    'Just show date and time
            '                    'rtb = bDate.Year.ToString + "/" + bDate.Month.ToString + "/" + bDate.Day.ToString + " " + aDate.ToShortTimeString
            '                    rtb = Util.CvtRTF2Text(myDataRow("ItemNote"))
            '                Else
            '                    rtb = myDataRow("ItemNote")
            '                End If

            '                bDate = CDate(myDataRow("ItemDate").ToString())
            '                aDate = CDate(myDataRow("ItemTime").ToString())

            '                rtb = myDataRow("AttachmentID").ToString() + ": (" + bDate.Year.ToString + "/" + bDate.Month.ToString + "/" + bDate.Day.ToString + ") " + Util.titleText(rtb)

            '                Dim imageNode As New TreeNode(rtb)

            '                If myDataRow("SignOff") Then
            '                    imageNode.ImageUrl = "~/AIA/Images/ImageClosed.jpg"
            '                Else
            '                    imageNode.ImageUrl = "~/AIA/Images/xrayIcon1.jpg"
            '                End If



            '                If (theFilter = ALLMODE) Then

            '                    'Me.tvType.Nodes(0).Nodes(3).Nodes(ATIMAGE).Nodes.Add(New TreeNode(myDataRow("AttachmentID").ToString() + ": (" + myDataRow("ItemTime").ToString() + ") " + titleText(rtb.Text), iconIndex, iconIndex))
            '                    attImagesNode.ChildNodes.Add(imageNode)
            '                Else

            '                    'Me.tvType.Nodes(0).Nodes(0).Nodes(ATIMAGE).Nodes.Add(New TreeNode(myDataRow("AttachmentID").ToString() + ": (" + myDataRow("ItemTime").ToString() + ") " + titleText(rtb.Text), iconIndex, iconIndex))
            '                    attImagesNode.ChildNodes.Add(imageNode)
            '                End If

            '            End If


            '        Next
            '    End If

            'End If
            'If ((theFilter = ALLMODE) Or (theFilter = SCANMODE)) Then


            '    'If (Not (aNote Is Nothing)) Then
            '    '    If (aNote.Length() > 50) Then aNote.Substring(50)
            '    'End If


            '    Dim scnNode As New TreeNode("Scanned Documents")
            '    scnNode.ImageUrl = "~/AIA/Images/ScaneEncounters.jpg"

            '    If (theFilter = ALLMODE) Then
            '        attNode.ChildNodes.Add(scnNode)

            '    Else
            '        attNode.ChildNodes.Add(scnNode)
            '    End If




            '    If (Not (DcDbProvider.Tables("Attachments") Is Nothing)) Then


            '        For Each myDataRow In DcDbProvider.Rows("Attachments")

            '            If (myDataRow("SSN").ToString() = SSN) And (myDataRow("ItemType") = ATENCOUNTER) Then

            '                If myDataRow("RTF") Then
            '                    'Just show date and time

            '                    ' rtb = bDate.Year.ToString + "/" + bDate.Month.ToString + "/" + bDate.Day.ToString + " " + aDate.ToShortTimeString
            '                    rtb = Util.CvtRTF2Text(myDataRow("ItemNote"))
            '                Else
            '                    rtb = myDataRow("ItemNote")
            '                End If
            '                bDate = CDate(myDataRow("ItemDate").ToString())
            '                aDate = CDate(myDataRow("ItemTime").ToString())

            '                rtb = myDataRow("AttachmentID").ToString() + ": (" + bDate.Year.ToString + "/" + bDate.Month.ToString + "/" + bDate.Day.ToString + ") " + Util.titleText(rtb)


            '                Dim scansNode As New TreeNode(rtb)


            '                If myDataRow("SignOff") Then
            '                    scansNode.ImageUrl = "~/AIA/Images/SCANClosed.jpg"
            '                Else
            '                    scansNode.ImageUrl = "~/AIA/Images/SCAN.jpg"
            '                End If



            '                If (theFilter = ALLMODE) Then
            '                    'Me.tvType.Nodes(0).Nodes(3).Nodes(ATENCOUNTER).Nodes.Add(New TreeNode(myDataRow("AttachmentID").ToString() + ": (" + myDataRow("ItemTime").ToString() + ") " + titleText(rtb.Text), iconIndex, iconIndex))
            '                    scnNode.ChildNodes.Add(scansNode)
            '                Else
            '                    'Me.tvType.Nodes(0).Nodes(0).Nodes(ATENCOUNTER).Nodes.Add(New TreeNode(myDataRow("AttachmentID").ToString() + ": (" + myDataRow("ItemTime").ToString() + ") " + titleText(rtb.Text), iconIndex, iconIndex))
            '                    scnNode.ChildNodes.Add(scansNode)
            '                End If


            '            End If


            '        Next
            '    End If
            'End If
            'If (theFilter = ALLMODE) Then


            '    Dim rptNode As New TreeNode("Reports")
            '    rptNode.ImageUrl = "~/AIA/Images/REPORTS2.jpg"

            '    If (theFilter = ALLMODE) Then
            '        aNode.ChildNodes.Add(rptNode)
            '    End If

            'End If


            If (theFilter = ALLMODE) Then
                Dim soNode As New TreeNode("Rules")
                soNode.ImageUrl = "~/AIA/Images/rulesTree.jpg"

                If (theFilter = ALLMODE) Then
                    aNode.ChildNodes.Add(soNode)
                End If


            End If

            If ((theFilter = ALLMODE) Or (theFilter = DEMOMODE)) Then

                Dim demoNode As New TreeNode("Profile")
                demoNode.ImageUrl = "~/AIA/Images/users2Tree.jpg"
                aNode.ChildNodes.Add(demoNode)
            End If

        Catch myException As Exception
            MsgBox(myException.ToString(), MsgBoxStyle.Critical, "Error from populateTemplateList Sub")
        Finally

            'MainWin.FormWaitClosed()

        End Try






    End Sub

    Protected Sub bTab1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles bTab1.Click
        ContentPanel.Height = pView.Height
        DetailContentPanel.Height = ContentPanel.Height

        'setPrevView()
        'mvTabs.ActiveViewIndex = 0
        'getView()
        bTab1.BorderStyle = BorderStyle.Inset
        bTab2.BorderStyle = BorderStyle.None
        bTab3.BorderStyle = BorderStyle.None
        bTab4.BorderStyle = BorderStyle.None

        pView.Visible = True
        pWorklet.Visible = False
        pQuery.Visible = False
        pOntology.Visible = False
        pRule.Visible = False
        'pProfile.Visible = False

    End Sub

    Protected Sub bTab2_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles bTab2.Click
        'Dim myDataRow As DataRow
        'setView()
        ' mvTabs.ActiveViewIndex = 1
        'getPrevView()

        ContentPanel.Height = pWorklet.Height
        DetailContentPanel.Height = ContentPanel.Height

        bTab1.BorderStyle = BorderStyle.None
        bTab2.BorderStyle = BorderStyle.Inset
        bTab3.BorderStyle = BorderStyle.None
        bTab4.BorderStyle = BorderStyle.None
        bTab5.BorderStyle = BorderStyle.None
        bTab6.BorderStyle = BorderStyle.None

        pView.Visible = False
        pWorklet.Visible = True
        pQuery.Visible = False
        pOntology.Visible = False
        pRule.Visible = False
        'pProfile.Visible = False




        'If (Not (DcDbProvider.Tables("InfoGlue.Worklets") Is Nothing)) Then

        '    For Each myDataRow In DcDbProvider.Rows("InfoGlue.Worklets")

        '        Dim aFile As String = (myDataRow("Path").ToString()) + (myDataRow("Worklet").ToString()) + ".bpel"
        '        processXML(aFile)

        '    Next
        'End If





    End Sub

    Protected Sub bTab3_Click(ByVal sender As Object, ByVal e As System.EventArgs)

        ContentPanel.Height = pQuery.Height
        DetailContentPanel.Height = ContentPanel.Height

        bTab1.BorderStyle = BorderStyle.None
        bTab2.BorderStyle = BorderStyle.None
        bTab3.BorderStyle = BorderStyle.Inset
        bTab4.BorderStyle = BorderStyle.None
        bTab5.BorderStyle = BorderStyle.None
        bTab6.BorderStyle = BorderStyle.None

        pView.Visible = False
        pWorklet.Visible = False
        pQuery.Visible = True
        pOntology.Visible = False
        pRule.Visible = False
        'pProfile.Visible = False



    End Sub

    Protected Sub bTab4_Click(ByVal sender As Object, ByVal e As System.EventArgs)

        ContentPanel.Height = pOntology.Height
        DetailContentPanel.Height = ContentPanel.Height

        bTab1.BorderStyle = BorderStyle.None
        bTab2.BorderStyle = BorderStyle.None
        bTab3.BorderStyle = BorderStyle.None
        bTab4.BorderStyle = BorderStyle.Inset
        bTab5.BorderStyle = BorderStyle.None
        bTab6.BorderStyle = BorderStyle.None

        pView.Visible = False
        pWorklet.Visible = False
        pQuery.Visible = False
        pOntology.Visible = True
        pRule.Visible = False
        'pProfile.Visible = False

    End Sub

    Protected Sub bTab5_Click(ByVal sender As Object, ByVal e As System.EventArgs)

        ContentPanel.Height = pRule.Height
        DetailContentPanel.Height = ContentPanel.Height



        bTab1.BorderStyle = BorderStyle.None
        bTab2.BorderStyle = BorderStyle.None
        bTab3.BorderStyle = BorderStyle.None
        bTab4.BorderStyle = BorderStyle.None
        bTab5.BorderStyle = BorderStyle.Inset
        bTab6.BorderStyle = BorderStyle.None

        pView.Visible = False
        pWorklet.Visible = False
        pQuery.Visible = False
        pOntology.Visible = False
        pRule.Visible = True
        'pProfile.Visible = False
    End Sub

    Protected Sub bTab6_Click(ByVal sender As Object, ByVal e As System.EventArgs)

        ContentPanel.Height = pProfile.Height
        DetailContentPanel.Height = ContentPanel.Height

        bTab1.BorderStyle = BorderStyle.None
        bTab2.BorderStyle = BorderStyle.None
        bTab3.BorderStyle = BorderStyle.None
        bTab4.BorderStyle = BorderStyle.None
        bTab5.BorderStyle = BorderStyle.None
        bTab6.BorderStyle = BorderStyle.Inset

        pView.Visible = False
        pWorklet.Visible = False
        pQuery.Visible = False
        pOntology.Visible = False
        pRule.Visible = False
        pProfile.Visible = True
    End Sub

    Protected Sub processXML(ByVal aFile As String)
        'Dim xmlRoot As New SNANET.XMLParser.XMLRoot(Server.MapPath(aFile))
        Dim aTrans As String = ""
        Dim aWorklets As String = ""
        Dim i As Integer
        Dim xmlRoot As New SNANET.XMLParser.XMLRoot()
        xmlRoot.Name() = "process"
        xmlRoot.Path() = aFile
        xmlRoot.LoadXMLFile()

        If xmlRoot.isLoaded Then
            'Response.Write(xmlRoot.Children(0).Name & "=" & xmlRoot.Children(0).Value)
            '    MsgBox(xmlRoot.Children(0).Name & "=" & xmlRoot.Children(0).Value)
            '   For Each att As SNANET.XMLParser.XMLAttribute In xmlRoot.Attributes
            'Response.Write(att.Name & "=" & att.Value)
            ' MsgBox(att.Name & "=" & att.Value)
            'Next

            'Transitions
            'For testing and will be replace
            lT1.Text = ""
            lT2.Text = ""
            lT3.Text = ""
            lT4.Text = ""
            lT5.Text = ""
            lT6.Text = ""
            lT7.Text = ""
            lT7.Visible = False
            lT6.Visible = False
            lT5.Visible = False
            lT4.Visible = False
            lT3.Visible = False
            lT2.Visible = False
            lT1.Visible = False


            ibT1.Visible = False
            ibT2.Visible = False
            ibT3.Visible = False
            ibT4.Visible = False
            ibT5.Visible = False
            ibT6.Visible = False
            ibT7.Visible = False

            i = 1
            For Each item As SNANET.XMLParser.XMLNode In xmlRoot.GetNodesByName("sequence")
                'For Each item As SNANET.XMLParser.XMLNode In xmlRoot.Children.Item(i)

                aTrans = item.Attributes(0).Value()

                If (aTrans <> "start-up") Then


                    'This Temp Code will be replace with Diagram Lib.... Just for testing

                    Select Case i

                        Case 1

                            lT1.Text = aTrans
                            ibT1.Visible = True
                            lT1.Visible = True

                        Case 2
                            lT2.Text = aTrans
                            ibT2.Visible = True
                            lT2.Visible = True

                        Case 3
                            lT3.Text = aTrans
                            ibT3.Visible = True
                            lT3.Visible = True


                        Case 4
                            lT4.Text = aTrans
                            ibT4.Visible = True
                            lT4.Visible = True

                        Case 5
                            lT5.Text = aTrans
                            ibT5.Visible = True
                            lT5.Visible = True

                        Case 6
                            lT6.Text = aTrans
                            ibT6.Visible = True
                            lT6.Visible = True


                        Case 7
                            lT7.Text = aTrans
                            ibT7.Visible = True
                            lT7.Visible = True


                            'Case "?"

                            'Case Else   ' Conditional
                    End Select


                    i += 1

                End If


            Next


            i = 1
            'Worklets
            'For testing and will be replace
            lW1.Text = ""
            lW2.Text = ""
            lW3.Text = ""
            lW4.Text = ""
            lW5.Text = ""
            lW6.Text = ""
            lW7.Text = ""
            lW8.Text = ""
            lW8.Visible = False
            lW7.Visible = False
            lW6.Visible = False
            lW5.Visible = False
            lW4.Visible = False
            lW3.Visible = False
            lW2.Visible = False
            lW1.Visible = False


            ibW1.Visible = False
            ibW2.Visible = False
            ibW3.Visible = False
            ibW4.Visible = False
            ibW5.Visible = False
            ibW6.Visible = False
            ibW7.Visible = False
            ibW8.Visible = False

            For Each item As SNANET.XMLParser.XMLNode In xmlRoot.GetNodesByName("flow")
                aWorklets = item.Attributes(0).Value()

                Select Case i

                    Case 1

                        lW1.Text = aWorklets
                        ibW1.Visible = True
                        lW1.Visible = True

                    Case 2
                        lW2.Text = aWorklets
                        ibW2.Visible = True
                        lW2.Visible = True

                    Case 3
                        lW3.Text = aWorklets
                        ibW3.Visible = True
                        lW3.Visible = True

                    Case 4
                        lW4.Text = aWorklets
                        ibW4.Visible = True
                        lW4.Visible = True

                    Case 5
                        lW5.Text = aWorklets
                        ibW5.Visible = True
                        lW5.Visible = True

                    Case 6
                        lW6.Text = aWorklets
                        ibW6.Visible = True
                        lW6.Visible = True


                    Case 7
                        lW7.Text = aWorklets
                        ibW7.Visible = True
                        lW7.Visible = True


                    Case 8
                        lW8.Text = aWorklets
                        ibW8.Visible = True
                        lW8.Visible = True

                        'Case "?"
                        'Case Else   ' Conditional
                End Select


                i += 1


            Next
        End If
    End Sub




    Protected Sub TreeView1_SelectedNodeChanged1(ByVal sender As Object, ByVal e As System.EventArgs) Handles TreeViewOntology.SelectedNodeChanged
        If (TreeViewOntology.SelectedNode() Is Nothing) Or (TreeViewOntology.SelectedNode.Text = "Concepts") Then
            LabelConceptProperty.Text = "Properties of Concept:"
            GridViewOntProperties.DataSource = Nothing
            GridViewOntProperties.DataBind()
        Else
            Dim selectedNodeText As String
            selectedNodeText = TreeViewOntology.SelectedNode.Text
            Dim ontology As Hashtable = Session.Item("ontology")
            Dim selectedConcept As OntConcept = ontology.Item(TreeViewOntology.SelectedNode.Value)

            If Not selectedConcept Is Nothing Then
                LabelConceptProperty.Text = "Properties of Concept:  " + selectedConcept.getName()
            Else
                LabelConceptProperty.Text = "Properties of Concept:"
            End If

            If Not selectedConcept Is Nothing Then
                GridViewOntProperties.DataSource = selectedConcept.getPropertiesData()
                GridViewOntProperties.DataBind()
                GridViewOntProperties.Visible = True
            Else
                GridViewOntProperties.DataSource = Nothing
                GridViewOntProperties.DataBind()
            End If

        End If



    End Sub


    Protected Sub ButtonOntLoad_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        If TextBoxOntURL.Text <> "" And Uri.IsWellFormedUriString(TextBoxOntURL.Text, UriKind.RelativeOrAbsolute) Then
            Dim ontURI As Uri = New Uri(TextBoxOntURL.Text)
            Dim webClient As System.Net.WebClient = New Net.WebClient
            Dim response As IO.Stream = webClient.OpenRead(ontURI.ToString)

            Dim inputReader As IO.StreamReader = New IO.StreamReader(response)
            Dim displayString As String
            displayString = inputReader.ReadToEnd

            Dim nullString As Char = Microsoft.VisualBasic.ChrW(0)
            displayString = displayString.Trim(nullString)

            Dim ontologyService As OntologyWS.OntologyWSService

            ontologyService = New OntologyWS.OntologyWSService()

            Dim outputStr As String = ontologyService.loadOntology(displayString, RadioButtonListModelSpec.SelectedValue, RadioButtonListOntFormat.SelectedValue, False)

            TreeViewOntology.Nodes.Clear()

            'add ontology as a session item
            Dim ontology As New Hashtable
            Session.Item("ontology") = ontology

            Dim ontologyRootNode As New TreeNode
            TreeViewOntology.Nodes.Add(ontologyRootNode)

            Dim xmlDoc As System.Xml.XmlDocument = New System.Xml.XmlDocument
            xmlDoc.LoadXml(outputStr)
            Dim rootElement As System.Xml.XmlElement = xmlDoc.DocumentElement
            processElement(rootElement, ontologyRootNode)

            GridViewOntProperties.DataSource = Nothing
            GridViewOntProperties.DataBind()

            LabelConceptProperty.Text = "Properties of Concept:  "

        Else
            TextBoxOntURL.Text = "Invalid URI: " + TextBoxOntURL.Text
        End If
    End Sub

    Protected Function processElement(ByRef xmlNode As System.Xml.XmlNode, ByRef treeNode As TreeNode) As OntConcept
        treeNode.Text = xmlNode.Name
        Dim aConcept As New OntConcept

        Dim uriNode As System.Xml.XmlNode = xmlNode.Attributes.GetNamedItem("uri")
        If uriNode Is Nothing Then
            treeNode.ToolTip = xmlNode.Name
            treeNode.Value = xmlNode.Name
        Else
            treeNode.ToolTip = xmlNode.Attributes.GetNamedItem("uri").Value
            treeNode.Value = xmlNode.Attributes.GetNamedItem("uri").Value
            aConcept.setName(xmlNode.Name)
            aConcept.setUri(xmlNode.Attributes.GetNamedItem("uri").Value)

            Dim ontology As Hashtable = Session.Item("ontology")
            If Not ontology.ContainsKey(aConcept.getUri) Then
                ontology.Add(aConcept.getUri, aConcept)
            Else
                'Duplicate occurance of class due to multiple inheritence
                Dim existingConcept As OntConcept = ontology.Item(aConcept.getUri)
                Dim ienumSuper As IEnumerator = aConcept.getAllSuperClass.GetEnumerator
                While (ienumSuper.MoveNext)
                    Dim aSuperConcept As OntConcept = CType(ienumSuper.Current, OntConcept)
                    existingConcept.addSuperClass(aSuperConcept)
                End While
                aConcept = existingConcept
            End If


        End If


        Dim ienum As IEnumerator = xmlNode.GetEnumerator()
        Dim aClass As XmlNode
        While (ienum.MoveNext())
            aClass = CType(ienum.Current, XmlNode)
            If aClass.Name <> "HasProperties" Then
                Dim aClassNode As New TreeNode
                Dim aSubConcept As OntConcept = processElement(aClass, aClassNode)
                treeNode.ChildNodes.Add(aClassNode)
                aConcept.addSubClass(aSubConcept)
                aSubConcept.addSuperClass(aConcept)
            Else
                Dim ienumProperties As IEnumerator = aClass.GetEnumerator
                While (ienumProperties.MoveNext)
                    Dim aPropertyXMLNode As XmlNode = CType(ienumProperties.Current, XmlNode)
                    Dim aProperty As New OntProperty
                    aProperty.setName(aPropertyXMLNode.Name)
                    If Not aPropertyXMLNode.Attributes.GetNamedItem("uri") Is Nothing Then
                        aProperty.setUri(aPropertyXMLNode.Attributes.GetNamedItem("uri").Value)
                    End If
                    If Not aPropertyXMLNode.Attributes.GetNamedItem("domain") Is Nothing Then
                        aProperty.setDomain(aPropertyXMLNode.Attributes.GetNamedItem("domain").Value)
                    End If
                    If Not aPropertyXMLNode.Attributes.GetNamedItem("range") Is Nothing Then
                        aProperty.setRange(aPropertyXMLNode.Attributes.GetNamedItem("range").Value)
                    End If
                    aConcept.addProperty(aProperty)

                End While

            End If

        End While

        Return aConcept

    End Function



    Protected Sub RadioButtonListOntFormat_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs)

    End Sub
    '------------------------------------------------------Worklet Diagram------------------------------------------------------------
    '------------------------------------------------------------------------------------------------------------------

    Private Sub CreateWorkletDiagram()
        Dim palettepath As String = Server.MapPath(String.Empty)
        palettepath = palettepath & "\Images\FlowDiagramSymbols.edp"
        Dim palette As SymbolPalette = Me.LoadPalette(palettepath)

        ' Add a TextNode to highlight the subnode feature
        Dim text As String = "My Worklet"
        Dim units As MeasureUnits = MeasureUnits.Pixel
        Dim txtnode As Syncfusion.Windows.Forms.Diagram.TextNode = New TextNode(text)
        txtnode.FontStyle.Size = 18
        txtnode.FontStyle.Bold = True
        txtnode.FontStyle.Family = "Arial"
        txtnode.FontColorStyle.Color = Color.Black
        txtnode.LineStyle.LineColor = Color.Transparent
        ' for update size.
        txtnode.Text = text
        txtnode.SizeToText(New SizeF(500, 500))
        CType(txtnode, IUnitIndependent).SetPinPoint(New PointF(285, 30), units)
        Me.dwcWorklet.Model.AppendChild(txtnode)

        AddNode(palette, "Start", New PointF(50, 100))
        AddNode(palette, "Process", New PointF(185, 100))
        AddNode(palette, "Decision", New PointF(185, 200))
        AddNode(palette, "Document", New PointF(185, 400))
        AddNode(palette, "End", New PointF(320, 460))

        Dim node As Node = GetPaletteNode(palette, "Process")
        node = CType(node.Clone(), Node)
        CType(node, PathNode).Labels(0).Text = "Post-Process1"
        AppendNodeToDocument(node, New PointF(185, 300))

        ConnectNodes(GetModelNode("Start"), GetModelNode("Process"))
        ConnectNodes(GetModelNode("Process"), GetModelNode("Decision"))

        ConnectNodes(GetModelNode("Decision"), node)
        ConnectNodes(node, GetModelNode("Document"))
        ConnectNodes(GetModelNode("Document"), GetModelNode("End"))
    End Sub

    Private Sub ConnectNodes(ByVal node1 As Node, ByVal node2 As Node)
        If node1 Is Nothing Then
            Throw New ArgumentNullException("node1")
        End If
        If node2 Is Nothing Then
            Throw New ArgumentNullException("node2")
        End If

        ' enable center port
        node1.EnableCentralPort = True
        node2.EnableCentralPort = True

        ' create connector
        Dim conn As LineConnector = New LineConnector(New PointF(1, 1), New PointF(2, 2))

        ' set decorator
        Dim decor As Decorator = conn.HeadDecorator
        decor.DecoratorShape = DecoratorShape.FilledFancyArrow
        decor.FillStyle.Color = Color.Black

        Me.dwcWorklet.Model.AppendChild(conn)
        ' connect head end point
        Dim endPoint As EndPoint = conn.TailEndPoint
        node1.CentralPort.TryConnect(endPoint)
        ' connect tail end point
        endPoint = conn.HeadEndPoint
        node2.CentralPort.TryConnect(endPoint)
    End Sub

    Private Sub AddNode(ByVal palette As SymbolPalette, ByVal strNodeName As String, ByVal ptLocation As PointF)
        If palette Is Nothing Then
            Throw New ArgumentNullException("palette")
        End If
        If strNodeName Is Nothing Then
            Throw New ArgumentNullException("strNodeName")
        End If

        Dim nodeTemp As Node = GetPaletteNode(palette, strNodeName)

        If Not nodeTemp Is Nothing Then
            AppendNodeToDocument(nodeTemp, ptLocation)
        End If
    End Sub
    Private Sub AppendNodeToDocument(ByVal node As Node, ByVal ptLocation As PointF)
        If node Is Nothing Then
            Throw New ArgumentNullException("node")
        End If

        Dim szPinOffset As SizeF = (CType(node, IUnitIndependent)).GetPinPointOffset(MeasureUnits.Pixel)
        CType(node, IUnitIndependent).SetPinPoint(New PointF(ptLocation.X + szPinOffset.Width, ptLocation.Y + szPinOffset.Height), MeasureUnits.Pixel)
        Me.dwcWorklet.Model.AppendChild(node)
    End Sub
    ' Get the SymbolPalette by deserializing the SymbolPalette file
    Public Function LoadPalette(ByVal filename As String) As SymbolPalette
        Dim curSymbolPalette As SymbolPalette = Nothing
        Dim iStream As FileStream = New FileStream(filename, FileMode.Open, FileAccess.Read)

        If Not iStream Is Nothing Then
            Dim formatter As IFormatter = New BinaryFormatter()
            Try
                AddHandler AppDomain.CurrentDomain.AssemblyResolve, AddressOf Syncfusion.DiagramBaseAssembly.AssemblyResolver
                curSymbolPalette = CType(formatter.Deserialize(iStream), SymbolPalette)
            Catch e1 As SerializationException
                Try
                    formatter = New SoapFormatter()
                    iStream.Position = 0
                    curSymbolPalette = CType(formatter.Deserialize(iStream), SymbolPalette)
                Catch e As Exception
                    System.Diagnostics.Trace.WriteLine("Error reading SymbolPalette", e.Message)
                End Try
            Finally
                iStream.Close()
            End Try
        End If

        Return curSymbolPalette
    End Function
    Public Function GetModelNode(ByVal strNodeName As String) As Node
        If strNodeName Is Nothing Then
            Throw New ArgumentNullException("strNodeName")
        End If

        Dim nodeToReturn As Node = Nothing
        Dim model As Model = Me.dwcWorklet.Model

        If Not model Is Nothing Then
            For Each node As Node In model.Nodes
                If node.Name = strNodeName Then
                    nodeToReturn = node
                    Exit For
                End If
            Next node
        End If

        Return nodeToReturn
    End Function
    ' Get the SymbolModel from the SymbolPalette
    Public Function GetPaletteNode(ByVal palette As SymbolPalette, ByVal symbolName As String) As Node
        If palette Is Nothing Then
            Throw New ArgumentNullException("palette")
        End If

        If symbolName Is Nothing Then
            Throw New ArgumentNullException("symbolName")
        End If

        Dim nodeToReturn As Node = Nothing

        For Each node As Node In palette.Nodes
            If node.Name = symbolName Then
                nodeToReturn = node
                Exit For
            End If
        Next node

        Return nodeToReturn
    End Function




End Class
